//
//  StParameters.h
//  SvmTrainer
//
//  Created by 熊田 聖也 on 12/05/26.
//  Copyright (c) 2012年 __MyCompanyName__. All rights reserved.
//

#ifndef SvmTrainer_StParameters_h
#define SvmTrainer_StParameters_h

#include "Parameters.h"
#include <string>
#include <ostream>

struct SvmTrainerTag;

template<>
struct Parameters<SvmTrainerTag>
{
        std::string     input_positive_;
        std::string     input_negative_;
        std::string     output_svm_;
        std::string     kernel_type_;
        int             kernel_cache_size_;
        double          width_; // for chi2
        double          cost_;
        double          beta_; // for histogram-intersection
        
        Parameters()
                : output_svm_("./svm.bin"),
                  kernel_type_("chi2"), // histogram-intersection, gaussian
                  kernel_cache_size_(100),
                  width_(0.5),
                  cost_(1),
                  beta_(1.0) {}
};

typedef Parameters<SvmTrainerTag> StParameters;

template<>
inline std::ostream& operator<<(
        std::ostream&           os, 
        const StParameters&     params
) 
{
        os << "[parameters]\n";
        os << "input-positive: " << params.input_positive_ << std::endl;
        os << "input-negative: " << params.input_negative_ << std::endl;
        os << "output-svm: " << params.output_svm_ << std::endl;
        os << "kernel-type: " << params.kernel_type_ << std::endl;
        os << "kernel-cache-size: " << params.kernel_cache_size_ << std::endl;
        os << "width: " << params.width_ << std::endl;
        os << "cost: " << params.cost_ << std::endl;
        os << "beta: " << params.beta_ << std::endl;
        return os;
}


#endif
