//
//  SvmTrainer.h
//  SvmTrainer
//
//  Created by 熊田 聖也 on 12/05/26.
//  Copyright (c) 2012年 __MyCompanyName__. All rights reserved.
//

#ifndef SvmTrainer_SvmTrainer_h
#define SvmTrainer_SvmTrainer_h

#include "StParameters.h"
#include <boost/noncopyable.hpp>
#include <map>
namespace cv
{
        class Mat;
}
namespace shogun
{
        class CDotKernel;
        class CLibSVM;
}

class SvmTrainer : private boost::noncopyable 
{
public:
        SvmTrainer(const StParameters& params = StParameters());
        ~SvmTrainer();
        void execute(const cv::Mat& positive, const cv::Mat& negative);
        bool save(const std::string& svm_filename) const;
        shogun::CLibSVM* get_svm();
        bool load(const std::string& svm_filename);

private:
        const StParameters&     params_;
        shogun::CLibSVM*        svm_;
        typedef shogun::CDotKernel* (*GetKernel)(const StParameters& params); 
        std::map<std::string, GetKernel> get_kernel_;
};
#endif
